//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "THostForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "dbPackMateU"
#pragma resource "*.dfm"
TTestMate *TestMate;
//---------------------------------------------------------------------------
__fastcall TTestMate::TTestMate(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::FormCreate(TObject *Sender)
{
   GetTableList( cmbTables->Items );
   cmbTables->ItemIndex = cmbTables->Items->IndexOf(Table1->TableName);
}
//============================================================================
//
//   Function
//       GetTableList(TStrings *pTableList)
//
//   Input:
//       TStrings   -     TableName storage
//
//   Description:
//       populate a TStrings Object with TableNames
//       associated with the Database name of interest
//
//============================================================================
void __fastcall TTestMate::GetTableList( TStrings *pTableList )
{
  DBIResult     Rslt;           // return result
  hDBIDb        hTmpDb;         // Handle to the Database
  hDBIDb        hCur;           // pointer to the cursor Handle
  DBDesc        dbDesc;         // Database Decriptor
  TBLBaseDesc   ListDesc;       // Table Desciptor
  String        szDbName;       // database name
  String        szDbType;       // Database Type
  String        db_ext;

  szDbName = Table1->DatabaseName;
  // If szDbName = NULL it will create a
  // database object in the Local DIR ( app path )
  pTableList->Clear();

  Rslt = DbiOpenDatabase(szDbName.c_str(), NULL, dbiREADWRITE,
                          dbiOPENSHARED, NULL, 0, NULL, NULL, hTmpDb);
  if(!Rslt == DBIERR_NONE) {
      dbPackMateU1->Chk(Rslt);
     DbiInit(NULL);
     Rslt = DbiOpenDatabase(szDbName.c_str(), NULL, dbiREADWRITE,
                          dbiOPENSHARED, NULL, 0, NULL, NULL, hTmpDb);
     if(!Rslt == DBIERR_NONE) {
        // if the final attempt fails. cleanup and bail out.
        DbiExit();
        return;
     }
   }
  Rslt = DbiGetDatabaseDesc(szDbName.c_str(), &dbDesc);
  if ((Rslt == DBIERR_NONE) && (szDbName != NULL)) {
       if (stricmp(dbDesc.szDbType, "STANDARD") == 0)
         db_ext = "*.db*";
       else         // wildcards are ok (*.db?;*.db*)
         db_ext = "*.dbf";
    }
  else { // never got here before ?
        //Chk(Rslt);
        db_ext = "*.*";
    }

  // open the in memory list of TableNames
  // matching file extension search criteria
  Rslt = DbiOpenTableList(hTmpDb, False, False, db_ext.c_str(), hCur);
  if(!Rslt == DBIERR_NONE) {
     DbiCloseDatabase(hTmpDb);
     DbiExit();
     return;
    }
  while( DbiGetNextRecord( hCur, dbiNOLOCK, &ListDesc, 0 ) == DBIERR_NONE )
       {
         String szFullName = ListDesc.szName;
         AppendStr(szFullName, ".");
         AppendStr(szFullName, ListDesc.szExt);
         pTableList->Add( szFullName );
       }

  Rslt = DbiCloseCursor(hCur);
  if(!Rslt == DBIERR_NONE) {
     DbiExit();
    }


  Rslt = DbiCloseDatabase(hTmpDb);
  if(!Rslt == DBIERR_NONE) {
     DbiExit();
   }
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::cmbTablesChange(TObject *Sender)
{
    Table1->Close( );
    Table1->TableName = cmbTables->Items->Strings[
                             cmbTables->ItemIndex];
    Table1->Open( );
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::Button1Click(TObject *Sender)
{
   dbPackMateU1->VisiMode = chkVisi->Checked;
   dbPackMateU1->QuickPack();
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::Button2Click(TObject *Sender)
{    //========
    WindowState = wsMinimized;
    dbPackMateU1->VisiMode = chkVisi->Checked;
    dbPackMateU1->AlterLangDrv(  );
    WindowState = wsNormal;
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::Button3Click(TObject *Sender)
{   //====
    dbPackMateU1->VisiMode = chkVisi->Checked;
    dbPackMateU1->AlterTblLevel( );
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::Button4Click(TObject *Sender)
{   // =======
    // VisiMode OFF ERROR Checking OFF
    dbPackMateU1->VisiMode   = chkVisi->Checked;
    dbPackMateU1->ShowResult = chkVisi->Checked;
    DBIResult     Rslt;

    Rslt = dbPackMateU1->AlterBlockSze();
    if( Rslt != DBIERR_NONE )
        ShowMessage("BDE Error !!!");
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::Button5Click(TObject *Sender)
{    //======
    dbPackMateU1->VisiMode = chkVisi->Checked;
    dbPackMateU1->GenIndexs();
}
//---------------------------------------------------------------------------
void __fastcall TTestMate::Button6Click(TObject *Sender)
{    //=====
    Table1->Close();
}
//---------------------------------------------------------------------------

